# frozen_string_literal: true

# --------------------------------------------- #
# Author: [Patrick W. <"Sickday@pm.me">] ------ #
# InitDate: [3/5/20] ------------------------- #
# --------------------------------------------- #

module Strum::Internal::Events
  ##
  # Raised when a Session triggers an event
  class SessionEvent < GenericEvent
    ##
    # Creates a new Session event
    def initialize(params = {}, block)
      self[:Session] = params[:session] if params[:session]
      super(params, block)
    end
  end
  class SessionRegistrationEvent < SessionEvent; end
  ##
  # Raised when a Session is built.
  class SessionBuildEvent < SessionEvent; end
  ##
  # Raised when a Session is closed
  class SessionClosedEvent < SessionEvent; end
  ##
  # Raised when data is written to a Session's stream
  class SessionWriteEvent < SessionEvent; end
  ##
  # Raised when data is read from a Session's stream
  class SessionReadEvent < SessionEvent; end
end