# frozen_string_literal: true

# --------------------------------------------- #
# Author: [Patrick W. <"Sickday@pm.me">] ------ #
# InitDate: [3/3/20] ------------------------- #
# --------------------------------------------- #

module Strum
  module Internal
    ##
    # Generic module
    module Generic
      include Container
      ##
      # Builds this object.
      def build(*opt)
        raise Strum::Errors::ClosedGenericBuild if closed?
      end

      ##
      # Write to this object
      def write(*data)
        raise Strum::Errors::ClosedGenericIO if closed?
      end

      ##
      # Read from this object
      def read(*length)
        raise Strum::Errors::ClosedGenericIO if closed?
      end

      ##
      # Validates this packet before building.
      def validate
        raise Strum::Errors::ClosedGenericValidation if closed?
      end

      ##
      # Checks if this object is closed.
      def closed?
        self[:Status] == :CLOSED
      end

      ##
      # Updates this object status.
      def close!
        self[:Status] = :CLOSED
        self[:Status].freeze
        self.freeze
      end

      alias_method :<<, :write
    end
  end
end