# frozen_string_literal: true

# --------------------------------------------- #
# Author: [Patrick W. <"Sickday@pm.me">] ------ #
# InitDate: [3/7/20] ------------------------- #
# --------------------------------------------- #

module Strum::Server::Session
  ## Makes Session objects
  class Generator
    include Singleton
    include Strum::Internal::Component

    def initialize
      super(:Reactor)
    end
    ##
    # Generates a session from a socket.
    def generate(socket)
      begin
        Strum::Server::Session::Template.new(Socket: socket, InitTime: Time.now)
      rescue SocketError
        socket.close
        self[:Interceptor].close_socket(socket)
      end
    end
  end
end